/****************************************************************************
    NUT3W Numbering software for BSch3V
    Copyright (C) 1997-2014 H.Okada
*****************************************************************************/

// nu3w.cpp : AvP[ṼNX`܂B
//

#include "stdafx.h"
#include "nu3w.h"
#include "nu3wDlg.h"
#include "Global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Cnu3wApp

BEGIN_MESSAGE_MAP(Cnu3wApp, CWinApp)
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()


// Cnu3wApp RXgNV

Cnu3wApp::Cnu3wApp()
{
	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB


	TCHAR drive[_MAX_DRIVE];
	TCHAR dir[_MAX_DIR];
//	TCHAR pathModule[_MAX_PATH];
	TCHAR pathExe[_MAX_PATH];


	m_pszIniFileName = new TCHAR[_MAX_PATH];		//pXi[GÅm
												//MFCdeletêŁAŒGAmۂĂ͂ȂB

	//W[̃pX𒲂ׂB
	::GetModuleFileName(NULL,pathExe,_MAX_PATH);

	//Windows 2000/XPɂ
	//\Documents and Settings\username\Local Settings\Application Data\SuigyodoONLINE\NUT3W.INI TB
	//ꂪƂ́AINIt@CƂĎgB
	OSVERSIONINFO versionInfo;
	versionInfo.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	if(GetVersionEx(&versionInfo)){
		if(versionInfo.dwPlatformId == VER_PLATFORM_WIN32_NT){
			if(SHGetSpecialFolderPath(NULL,m_pszIniFileName,CSIDL_LOCAL_APPDATA,FALSE)){
				TRACE("CBSchApp::CBSchApp() %s\n",m_pszIniFileName);
				lstrcat(m_pszIniFileName,_T("\\SuigyodoONLINE\\NUT3W.INI"));
				FILE *pf=_wfopen(m_pszIniFileName,_T("rb"));
				if(pf){
					fclose(pf);
					m_pszProfileName=m_pszIniFileName;	//쐬̃|C^m_pszProfileNameɃRs[
					return;
				}
			}
		}
	}

	//ǂɂȂƂɂ̓W[̊i[tH_ INIt@Cg
	//ɂINIt@CȂƂ́AINIt@CVK쐬邪ȀꍇAVK쐬O0xFF,0xFẼt@CĂ
	::_tsplitpath(pathExe,drive,dir,NULL,NULL);
	::_tmakepath_s(m_pszIniFileName,_MAX_PATH,drive,dir,_T("NUT3W"),_T(".INI"));
	{
		FILE *pf=_tfopen(m_pszIniFileName,_T("rt"));
		if(pf){
			fclose(pf);
		}else{
			static const byte BOMDATA[2]={0xff,0xfe};
			pf=_tfopen(m_pszIniFileName,_T("wb"));
			if(pf){
				fwrite(BOMDATA,1,2,pf);
				fclose(pf);
			}
		}
	}

	m_pszProfileName=m_pszIniFileName;	//쐬̃|C^m_pszProfileNameɃRs[


	g_maxInitValue =  AfxGetApp()->GetProfileInt(_T("OPTION"),_T("MaxInitValue"),1000);
	AfxGetApp()->WriteProfileInt(_T("OPTION"),_T("MaxInitValue"),g_maxInitValue);
	g_maxStepValue =  AfxGetApp()->GetProfileInt(_T("OPTION"),_T("MaxStepValue"),20);
	AfxGetApp()->WriteProfileInt(_T("OPTION"),_T("MaxStepValue"),g_maxStepValue);

	if(g_maxInitValue<100) g_maxInitValue=100;
	else if(g_maxInitValue>100000) g_maxInitValue=100000;

	if(g_maxStepValue<2) g_maxStepValue=2;
	else if(g_maxStepValue>100) g_maxStepValue=100;


}


// B Cnu3wApp IuWFNgłB

Cnu3wApp theApp;


// Cnu3wApp 

BOOL Cnu3wApp::InitInstance()
{
	ParseCommandLine(m_cmdInfo);


	// Version 0.69 20101016
	//DLL̓ǂݍ݃pXst@C̃fBNgɐ
	TCHAR moduleFileName[_MAX_PATH];
	TCHAR dllPath[_MAX_PATH];
	TCHAR drive[_MAX_DRIVE];
	TCHAR dir[_MAX_DIR];
	::GetModuleFileName(NULL,moduleFileName,_MAX_PATH);
	::_tsplitpath(moduleFileName,drive,dir,NULL,NULL);
	::_tmakepath(dllPath,drive,dir,_T("nu3w_lang"),_T("dll"));
	//܂ Version 0.69 20101016



	//ꃊ\[XDLLǂݍޑÕ\[X̃o[Wƃ\[Xnh̕ۑ
	CString strVersion;
	strVersion.LoadString(IDS_VERSION);
	HINSTANCE hInstRcOrg = AfxGetResourceHandle();

	HINSTANCE hInstRc = LoadLibrary( dllPath ); //Version 0.69 20101016

	if ( hInstRc){				// ꃊ\[XDLL.
		AfxSetResourceHandle(hInstRc);
		//ꃊ\[X̃o[W`FbN
		CString strVersionAddRc;
		strVersionAddRc.LoadString(IDS_VERSION);
		//o[WvȂ΁Ã\[Xnhɖ߂
		if(strVersion.Compare(strVersionAddRc)!=0){
			AfxSetResourceHandle(hInstRcOrg);
		}
	}


	//HINSTANCE hInstRc = LoadLibrary( "nu3w_lang.dll");
	//if ( hInstRc){				// ꃊ\[XDLL.
	//	AfxSetResourceHandle(hInstRc);
	//}

	// AvP[V@}jtFXg@visual X^CLɂ邽߂ɁA
	// ComCtl32.dll o[W 6@ȍ~̎gpw肷ꍇ́A
	// Windows XP Ɂ@InitCommonControls() KvłBȂ΁AEBhE쐬ׂ͂Ďs܂B
	InitCommonControls();

	CWinApp::InitInstance();

	AfxEnableControlContainer();

	// W
	// ̋@\g킸ɁAŏIIȎs\t@C̃TCYkꍇ́A
	// ȉAsvȏ[`
	// 폜ĂB
	// ݒ肪i[Ă郌WXg L[ύX܂B
	// TODO: ̕AЖ܂͑gDȂǂ́A
	// K؂ȕɕύXĂB
	// SetRegistryKey(_T("AvP[V EBU[hŐꂽ[J AvP[V"));

	Cnu3wDlg dlg;
	m_pMainWnd = &dlg;
	INT_PTR nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: _CAO <OK> ŏꂽ̃R[h
		//       LqĂB
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: _CAO <LZ> ŏꂽ̃R[h
		//       LqĂB
	}

	// _CAO͕܂BAvP[ṼbZ[W |vJnȂ
	// AvP[VI邽߂ FALSE ԂĂB
	return FALSE;
}
