/****************************************************************************
    BSch3V schematic capture
	Copyright (C) 1997-2014 H.Okada
*****************************************************************************/

#pragma once
#include "sptnobj.h"

class SPtnObjLine :	public SPtnObj
{
public:
	//ʂ̃C^[tF[X
	SPtnObjLine(void);
	~SPtnObjLine(void);
	int id(){return VECTPTN_L;}
//	SPtnObjLine(const SPtnObjLine&);				//Rs[RXgN^
//	SPtnObjLine& operator=(const SPtnObjLine&);		//Zq
	SPtnObj* duplicate();								//
	bool qValid();									//Lȃf[^ǂԂB

	//Obv̐Ԃ
	int gripCount(){return 2;}
	//Obv̈ʒuԂ
	SPoint gripPos(int grip);
	//Obv̈ʒu𓮂
	void setGripPos(int grip,int x,int y);



	void move(int offsetx,int offsety);				//ʒu𓮂
	void mirrorH(int x); 							//XWw肵čE]s
	void mirrorH();									//E]s
	void rotate(const SPoint& p);					//XYSWw肵āA]s
	void rotate();									//]s
	bool testIntersect(const SRect& );				//͈͂w肵đI`FbNs
	bool testIntersect(const SPoint& );				//_w肵đI`FbNs
	SRect area();									//L͈͂Ԃ
	bool readCe3(SReadCE3& rce3);
	bool writeCe3(SWriteCE3& wce3,SPoint* pOrigin=NULL);
public:
	SPoint m_p0;
	SPoint m_p1;
};
